
def loadData(filename):
    f=open(filename)
    dic={}    
    for row in f.readlines():
        data=row.split()
        dic[data[0]]=data[1]
    f.close()
    return dic

def findPalindromes(seq, k):
    palindromes={}
    for i in range(len(seq)-k):
        sub=seq[i:i+k]
        rev=list(seq[i+k:i+2*k])
        rev.reverse()
        rev="".join(rev)
        if sub == rev:
            palindrome=(seq[i:i+2*k])
            if not palindromes.has_key(palindrome):
                palindromes[palindrome]=1
            else:
                palindromes[palindrome]+=1
    return palindromes

def findRepetitions(seq):
    repetitions={}
    for i in range(len(seq)):
        for j in range(i+1,len(seq)):
            if seq[j]!=seq[i] or j==len(seq)-1:
                repetition=seq[i:j]
                if not repetitions.has_key(repetition):
                    repetitions[repetition]=1
                else:
                    repetitions[repetition]+=1
                break                
    return repetitions

def printRepetitions(seqname,repetitions):
    print(seqname)
    print(" ".join(["%s:%d" % (pal,num) for (pal,num) in repetitions.items()]))


def extractRepetitions(filename):

    data=loadData(filename)

    for (name,seq) in data.items():
        repetitions=findRepetitions(seq)
        if repetitions:
            printRepetitions(name,repetitions)

extractRepetitions('utr.txt')
